Index: branches/HTM-14.1-update-dev0/source/App/TAppEncoder/TAppEncCfg.cpp
===================================================================
--- branches/HTM-14.1-update-dev0/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 1200)
@@ -827,6 +1394,6 @@
 
 
-      for( Int i = 1; i < MAX_GOP + 1; i++ ) 
-      {
+  for(Int i=1; i<MAX_GOP+1; i++)
+  {
         std::ostringstream cOSS2;
         cOSS2<<"Frame"<<i<<"_l"<<k;
@@ -840,5 +1407,6 @@
   }
 #else
-  for(Int i=1; i<MAX_GOP+1; i++) {
+  for(Int i=1; i<MAX_GOP+1; i++)
+  {
     std::ostringstream cOSS;
     cOSS<<"Frame"<<i;
@@ -847,5 +1415,40 @@
 #endif
   po::setDefaults(opts);
-  const list<const Char*>& argv_unhandled = po::scanArgv(opts, argc, (const Char**) argv);
+  po::ErrorReporter err;
+  const list<const Char*>& argv_unhandled = po::scanArgv(opts, argc, (const Char**) argv, err);
+
+  for (list<const Char*>::const_iterator it = argv_unhandled.begin(); it != argv_unhandled.end(); it++)
+  {
+    fprintf(stderr, "Unhandled argument ignored: `%s'\n", *it);
+  }
+
+  if (argc == 1 || do_help)
+  {
+    /* argc == 1: no options have been specified */
+    po::doHelp(cout, opts);
+    return false;
+  }
+
+  if (err.is_errored)
+  {
+    if (!warnUnknowParameter)
+    {
+      /* error report has already been printed on stderr */
+      return false;
+    }
+  }
+
+  /*
+   * Set any derived parameters
+   */
+  /* convert std::string to c string for compatability */
+#if !NH_MV
+  m_pchInputFile = cfg_InputFile.empty() ? NULL : strdup(cfg_InputFile.c_str());
+#endif
+  m_pchBitstreamFile = cfg_BitstreamFile.empty() ? NULL : strdup(cfg_BitstreamFile.c_str());
+#if !NH_MV
+  m_pchReconFile = cfg_ReconFile.empty() ? NULL : strdup(cfg_ReconFile.c_str());
+#endif
+  m_pchdQPFile = cfg_dQPFile.empty() ? NULL : strdup(cfg_dQPFile.c_str());
 
   if(m_isField)
@@ -858,55 +1461,25 @@
     m_framesToBeEncoded *= 2;
   }
-  
-  for (list<const Char*>::const_iterator it = argv_unhandled.begin(); it != argv_unhandled.end(); it++)
-  {
-    fprintf(stderr, "Unhandled argument ignored: `%s'\n", *it);
-  }
-  
-  if (argc == 1 || do_help)
-  {
-    /* argc == 1: no options have been specified */
-    po::doHelp(cout, opts);
-    return false;
-  }
-  
-  /*
-   * Set any derived parameters
-   */
-  /* convert std::string to c string for compatability */
-#if !H_MV
-  m_pchInputFile = cfg_InputFile.empty() ? NULL : strdup(cfg_InputFile.c_str());
-#endif
-  m_pchBitstreamFile = cfg_BitstreamFile.empty() ? NULL : strdup(cfg_BitstreamFile.c_str());
-#if !H_MV
-  m_pchReconFile = cfg_ReconFile.empty() ? NULL : strdup(cfg_ReconFile.c_str());
-#endif
-  m_pchdQPFile = cfg_dQPFile.empty() ? NULL : strdup(cfg_dQPFile.c_str());
-  
-  Char* pColumnWidth = cfgColumnWidth.empty() ? NULL: strdup(cfgColumnWidth.c_str());
-  Char* pRowHeight = cfgRowHeight.empty() ? NULL : strdup(cfgRowHeight.c_str());
 
   if( !m_tileUniformSpacingFlag && m_numTileColumnsMinus1 > 0 )
   {
-    char *str;
-    int  i=0;
-    m_tileColumnWidth.resize( m_numTileColumnsMinus1 );
-    str = strtok(pColumnWidth, " ,-");
-    while(str!=NULL)
-    {
-      if( i >= m_numTileColumnsMinus1 )
-      {
-        printf( "The number of columns whose width are defined is larger than the allowed number of columns.\n" );
-        exit( EXIT_FAILURE );
-      }
-      m_tileColumnWidth[i] = atoi( str );
-      str = strtok(NULL, " ,-");
-      i++;
-    }
-    if( i < m_numTileColumnsMinus1 )
+    if (cfg_ColumnWidth.values.size() > m_numTileColumnsMinus1)
+    {
+      printf( "The number of columns whose width are defined is larger than the allowed number of columns.\n" );
+      exit( EXIT_FAILURE );
+    }
+    else if (cfg_ColumnWidth.values.size() < m_numTileColumnsMinus1)
     {
       printf( "The width of some columns is not defined.\n" );
       exit( EXIT_FAILURE );
     }
+    else
+    {
+      m_tileColumnWidth.resize(m_numTileColumnsMinus1);
+      for(UInt i=0; i<cfg_ColumnWidth.values.size(); i++)
+      {
+        m_tileColumnWidth[i]=cfg_ColumnWidth.values[i];
+      }
+    }
   }
   else
@@ -917,24 +1490,22 @@
   if( !m_tileUniformSpacingFlag && m_numTileRowsMinus1 > 0 )
   {
-    char *str;
-    int  i=0;
-    m_tileRowHeight.resize(m_numTileRowsMinus1);
-    str = strtok(pRowHeight, " ,-");
-    while(str!=NULL)
-    {
-      if( i>=m_numTileRowsMinus1 )
-      {
-        printf( "The number of rows whose height are defined is larger than the allowed number of rows.\n" );
-        exit( EXIT_FAILURE );
-      }
-      m_tileRowHeight[i] = atoi( str );
-      str = strtok(NULL, " ,-");
-      i++;
-    }
-    if( i < m_numTileRowsMinus1 )
+    if (cfg_RowHeight.values.size() > m_numTileRowsMinus1)
+    {
+      printf( "The number of rows whose height are defined is larger than the allowed number of rows.\n" );
+      exit( EXIT_FAILURE );
+    }
+    else if (cfg_RowHeight.values.size() < m_numTileRowsMinus1)
     {
       printf( "The height of some rows is not defined.\n" );
       exit( EXIT_FAILURE );
-   }
+    }
+    else
+    {
+      m_tileRowHeight.resize(m_numTileRowsMinus1);
+      for(UInt i=0; i<cfg_RowHeight.values.size(); i++)
+      {
+        m_tileRowHeight[i]=cfg_RowHeight.values[i];
+      }
+    }
   }
   else
@@ -942,18 +1513,197 @@
     m_tileRowHeight.clear();
   }
-#if H_MV
-  free ( pColumnWidth );
-  free ( pRowHeight   ); 
-#endif
+
   m_scalingListFile = cfg_ScalingListFile.empty() ? NULL : strdup(cfg_ScalingListFile.c_str());
-  
+
   /* rules for input, output and internal bitdepths as per help text */
-  if (!m_internalBitDepthY) { m_internalBitDepthY = m_inputBitDepthY; }
-  if (!m_internalBitDepthC) { m_internalBitDepthC = m_internalBitDepthY; }
-  if (!m_inputBitDepthC) { m_inputBitDepthC = m_inputBitDepthY; }
-  if (!m_outputBitDepthY) { m_outputBitDepthY = m_internalBitDepthY; }
-  if (!m_outputBitDepthC) { m_outputBitDepthC = m_internalBitDepthC; }
-
-  // TODO:ChromaFmt assumes 4:2:0 below
+  if (m_MSBExtendedBitDepth[CHANNEL_TYPE_LUMA  ] == 0)
+  {
+    m_MSBExtendedBitDepth[CHANNEL_TYPE_LUMA  ] = m_inputBitDepth      [CHANNEL_TYPE_LUMA  ];
+  }
+  if (m_MSBExtendedBitDepth[CHANNEL_TYPE_CHROMA] == 0)
+  {
+    m_MSBExtendedBitDepth[CHANNEL_TYPE_CHROMA] = m_MSBExtendedBitDepth[CHANNEL_TYPE_LUMA  ];
+  }
+  if (m_internalBitDepth   [CHANNEL_TYPE_LUMA  ] == 0)
+  {
+    m_internalBitDepth   [CHANNEL_TYPE_LUMA  ] = m_MSBExtendedBitDepth[CHANNEL_TYPE_LUMA  ];
+  }
+  if (m_internalBitDepth   [CHANNEL_TYPE_CHROMA] == 0)
+  {
+    m_internalBitDepth   [CHANNEL_TYPE_CHROMA] = m_internalBitDepth   [CHANNEL_TYPE_LUMA  ];
+  }
+  if (m_inputBitDepth      [CHANNEL_TYPE_CHROMA] == 0)
+  {
+    m_inputBitDepth      [CHANNEL_TYPE_CHROMA] = m_inputBitDepth      [CHANNEL_TYPE_LUMA  ];
+  }
+  if (m_outputBitDepth     [CHANNEL_TYPE_LUMA  ] == 0)
+  {
+    m_outputBitDepth     [CHANNEL_TYPE_LUMA  ] = m_internalBitDepth   [CHANNEL_TYPE_LUMA  ];
+  }
+  if (m_outputBitDepth     [CHANNEL_TYPE_CHROMA] == 0)
+  {
+    m_outputBitDepth     [CHANNEL_TYPE_CHROMA] = m_internalBitDepth   [CHANNEL_TYPE_CHROMA];
+  }
+
+  m_InputChromaFormatIDC = numberToChromaFormat(tmpInputChromaFormat);
+  m_chromaFormatIDC      = ((tmpChromaFormat == 0) ? (m_InputChromaFormatIDC) : (numberToChromaFormat(tmpChromaFormat)));
+
+#if NH_MV
+  // parse PTL
+  Bool anyEmpty = false; 
+  if( cfg_profiles.empty() )
+  {
+#if NH_3D
+    cfg_profiles = string("main main 3d-main");
+#else
+    cfg_profiles = string("main main multiview-main");    
+#endif
+    fprintf(stderr, "\nWarning: No profiles given, using defaults: %s", cfg_profiles.c_str() );
+    anyEmpty = true; 
+  }
+
+  if( cfg_levels.empty() )
+  {
+    cfg_levels = string("5.1 5.1 5.1");
+    fprintf(stderr, "\nWarning: No levels given, using defaults: %s", cfg_levels.c_str() );
+    anyEmpty = true; 
+  }
+
+  if( cfg_tiers.empty() )
+  {
+    cfg_tiers = string("main main main");
+    fprintf(stderr, "\nWarning: No tiers given, using defaults: %s", cfg_tiers.c_str());
+    anyEmpty = true; 
+  }
+
+  if( m_inblFlag.empty() )
+  {
+    fprintf(stderr, "\nWarning: No inblFlags given, using defaults:");
+    for( Int i = 0; i < 3; i++)
+    {
+      m_inblFlag.push_back( false );
+      fprintf(stderr," %d", (Int) m_inblFlag[i]);
+    }
+    anyEmpty = true; 
+  }   
+
+  if ( anyEmpty )
+  {
+    fprintf( stderr, "\n" );
+  }
+
+  xReadStrToEnum( cfg_profiles, extendedProfiles  ); 
+  xReadStrToEnum( cfg_levels,   m_level     ); 
+  xReadStrToEnum( cfg_tiers ,   m_levelTier ); 
+
+
+#if NH_MV
+  m_profiles.resize( extendedProfiles.size()); 
+
+  for (Int i = 0; i < m_profiles.size(); i++)
+  {
+    Profile::Name& m_profile             = m_profiles      [i];  
+    ExtendedProfileName& extendedProfile = extendedProfiles[i];  
+#endif
+#endif
+
+  if (extendedProfile >= 1000 && extendedProfile <= 12316)
+    {
+      m_profile = Profile::MAINREXT;
+      if (m_bitDepthConstraint != 0 || tmpConstraintChromaFormat != 0)
+      {
+        fprintf(stderr, "Error: The bit depth and chroma format constraints are not used when an explicit RExt profile is specified\n");
+        exit(EXIT_FAILURE);
+      }
+      m_bitDepthConstraint     = (extendedProfile%100);
+    m_intraConstraintFlag          = ((extendedProfile%10000)>=2000);
+    m_onePictureOnlyConstraintFlag = (extendedProfile >= 10000);
+      switch ((extendedProfile/100)%10)
+      {
+      case 0:  tmpConstraintChromaFormat=400; break;
+      case 1:  tmpConstraintChromaFormat=420; break;
+      case 2:  tmpConstraintChromaFormat=422; break;
+      default: tmpConstraintChromaFormat=444; break;
+      }
+    }
+    else
+    {
+      m_profile = Profile::Name(extendedProfile);
+    }
+
+    if (m_profile == Profile::HIGHTHROUGHPUTREXT )
+    {
+      if (m_bitDepthConstraint == 0)
+      {
+        m_bitDepthConstraint = 16;
+      }
+      m_chromaFormatConstraint = (tmpConstraintChromaFormat == 0) ? CHROMA_444 : numberToChromaFormat(tmpConstraintChromaFormat);
+    }
+    else if (m_profile == Profile::MAINREXT)
+    {
+      if (m_bitDepthConstraint == 0 && tmpConstraintChromaFormat == 0)
+      {
+        // produce a valid combination, if possible.
+      const Bool bUsingGeneralRExtTools  = m_transformSkipRotationEnabledFlag        ||
+                                           m_transformSkipContextEnabledFlag         ||
+                                           m_rdpcmEnabledFlag[RDPCM_SIGNAL_IMPLICIT] ||
+                                           m_rdpcmEnabledFlag[RDPCM_SIGNAL_EXPLICIT] ||
+          !m_enableIntraReferenceSmoothing         ||
+                                           m_persistentRiceAdaptationEnabledFlag     ||
+                                           m_log2MaxTransformSkipBlockSize!=2;
+      const Bool bUsingChromaQPAdjustment= m_diffCuChromaQpOffsetDepth >= 0;
+      const Bool bUsingExtendedPrecision = m_extendedPrecisionProcessingFlag;
+      if (m_onePictureOnlyConstraintFlag)
+      {
+        m_chromaFormatConstraint = CHROMA_444;
+        if (m_intraConstraintFlag != true)
+        {
+          fprintf(stderr, "Error: Intra constraint flag must be true when one_picture_only_constraint_flag is true\n");
+          exit(EXIT_FAILURE);
+        }
+        const Int maxBitDepth = m_chromaFormatIDC==CHROMA_400 ? m_internalBitDepth[CHANNEL_TYPE_LUMA] : std::max(m_internalBitDepth[CHANNEL_TYPE_LUMA], m_internalBitDepth[CHANNEL_TYPE_CHROMA]);
+        m_bitDepthConstraint = maxBitDepth>8 ? 16:8;
+      }
+      else
+      {
+        m_chromaFormatConstraint = NUM_CHROMA_FORMAT;
+        automaticallySelectRExtProfile(bUsingGeneralRExtTools,
+          bUsingChromaQPAdjustment,
+          bUsingExtendedPrecision,
+          m_intraConstraintFlag,
+          m_bitDepthConstraint,
+          m_chromaFormatConstraint,
+          m_chromaFormatIDC==CHROMA_400 ? m_internalBitDepth[CHANNEL_TYPE_LUMA] : std::max(m_internalBitDepth[CHANNEL_TYPE_LUMA], m_internalBitDepth[CHANNEL_TYPE_CHROMA]),
+          m_chromaFormatIDC);
+      }
+    }
+      else if (m_bitDepthConstraint == 0 || tmpConstraintChromaFormat == 0)
+      {
+        fprintf(stderr, "Error: The bit depth and chroma format constraints must either both be specified or both be configured automatically\n");
+        exit(EXIT_FAILURE);
+      }
+      else
+      {
+        m_chromaFormatConstraint = numberToChromaFormat(tmpConstraintChromaFormat);
+      }
+    }
+    else
+    {
+      m_chromaFormatConstraint = (tmpConstraintChromaFormat == 0) ? m_chromaFormatIDC : numberToChromaFormat(tmpConstraintChromaFormat);
+      m_bitDepthConstraint = (m_profile == Profile::MAIN10?10:8);
+    }
+#if NH_MV
+  }
+
+  if ( m_numberOfLayers != 0 && ( m_profiles[0] != Profile::MAIN || m_profiles[1] != Profile::MAIN )  )
+  {
+    fprintf(stderr, "Error: The base layer must conform to the Main profile for Multilayer coding.\n");
+    exit(EXIT_FAILURE);
+  }
+#endif
+
+
+  m_inputColourSpaceConvert = stringToInputColourSpaceConvert(inputColourSpaceConvert, true);
+
   switch (m_conformanceWindowMode)
   {
@@ -984,10 +1734,10 @@
         }
       }
-      if (m_aiPad[0] % TComSPS::getWinUnitX(CHROMA_420) != 0)
+      if (m_aiPad[0] % TComSPS::getWinUnitX(m_chromaFormatIDC) != 0)
       {
         fprintf(stderr, "Error: picture width is not an integer multiple of the specified chroma subsampling\n");
         exit(EXIT_FAILURE);
       }
-      if (m_aiPad[1] % TComSPS::getWinUnitY(CHROMA_420) != 0)
+      if (m_aiPad[1] % TComSPS::getWinUnitY(m_chromaFormatIDC) != 0)
       {
         fprintf(stderr, "Error: picture height is not an integer multiple of the specified chroma subsampling\n");
@@ -1020,7 +1770,13 @@
     }
   }
-  
+
   // allocate slice-based dQP values
-#if H_MV
+#if NH_MV
+  for (Int i = m_layerIdInNuh.size(); i < m_numberOfLayers; i++ )
+  {
+    m_layerIdInNuh.push_back( i == 0 ? 0 : m_layerIdInNuh[ i - 1 ] + 1 ); 
+  }
+  xResizeVector( m_layerIdInNuh ); 
+
   xResizeVector( m_viewOrderIndex    ); 
 
@@ -1041,5 +1797,5 @@
   xResizeVector( m_auxId );
 
-#if H_3D
+#if NH_3D
   xResizeVector( m_depthFlag ); 
 #endif
@@ -1062,4 +1818,23 @@
       {
         m_aidQP[layer][i] = 1;
+      }
+    }
+
+    for(UInt ch=0; ch<MAX_NUM_CHANNEL_TYPE; ch++)
+    {
+      if (saoOffsetBitShift[ch]<0)
+      {
+        if (m_internalBitDepth[ch]>10)
+        {
+          m_log2SaoOffsetScale[layer][ch]=UInt(Clip3<Int>(0, m_internalBitDepth[ch]-10, Int(m_internalBitDepth[ch]-10 + 0.165*m_iQP[layer] - 3.22 + 0.5) ) );
+        }
+        else
+        {
+          m_log2SaoOffsetScale[layer][ch]=0;
+        }
+      }
+      else
+      {
+        m_log2SaoOffsetScale[layer][ch]=UInt(saoOffsetBitShift[ch]);
       }
     }
@@ -1080,5 +1855,5 @@
   m_aidQP = new Int[ m_framesToBeEncoded + m_iGOPSize + 1 ];
   ::memset( m_aidQP, 0, sizeof(Int)*( m_framesToBeEncoded + m_iGOPSize + 1 ) );
-  
+
   // handling of floating-point QP values
   // if QP is not integer, sequence is split into two sections having QP and QP+1
@@ -1087,5 +1862,5 @@
   {
     Int iSwitchPOC = (Int)( m_framesToBeEncoded - (m_fQP - m_iQP)*m_framesToBeEncoded + 0.5 );
-    
+
     iSwitchPOC = (Int)( (Double)iSwitchPOC / m_iGOPSize + 0.5 )*m_iGOPSize;
     for ( Int i=iSwitchPOC; i<m_framesToBeEncoded + m_iGOPSize + 1; i++ )
@@ -1094,6 +1869,26 @@
     }
   }
-#endif
-  
+
+  for(UInt ch=0; ch<MAX_NUM_CHANNEL_TYPE; ch++)
+  {
+    if (saoOffsetBitShift[ch]<0)
+    {
+      if (m_internalBitDepth[ch]>10)
+      {
+        m_log2SaoOffsetScale[ch]=UInt(Clip3<Int>(0, m_internalBitDepth[ch]-10, Int(m_internalBitDepth[ch]-10 + 0.165*m_iQP - 3.22 + 0.5) ) );
+      }
+      else
+      {
+        m_log2SaoOffsetScale[ch]=0;
+      }
+    }
+    else
+    {
+      m_log2SaoOffsetScale[ch]=UInt(saoOffsetBitShift[ch]);
+    }
+  }
+
+#endif
+
   // reading external dQP description from file
   if ( m_pchdQPFile )
@@ -1102,5 +1897,5 @@
     if ( fpt )
     {
-#if H_MV
+#if NH_MV
       for( Int layer = 0; layer < m_numberOfLayers; layer++ )
       {
@@ -1110,6 +1905,9 @@
       while ( iPOC < m_framesToBeEncoded )
       {
-        if ( fscanf(fpt, "%d", &iValue ) == EOF ) break;
-#if H_MV
+        if ( fscanf(fpt, "%d", &iValue ) == EOF )
+        {
+          break;
+        }
+#if NH_MV
         m_aidQP[layer][ iPOC ] = iValue;
         iPOC++;
@@ -1123,26 +1921,28 @@
     }
   }
-  m_iWaveFrontSubstreams = m_iWaveFrontSynchro ? (m_iSourceHeight + m_uiMaxCUHeight - 1) / m_uiMaxCUHeight : 1;
-
+
+  if( m_masteringDisplay.colourVolumeSEIEnabled )
+  {
+    for(UInt idx=0; idx<6; idx++)
+    {
+      m_masteringDisplay.primaries[idx/2][idx%2] = UShort((cfg_DisplayPrimariesCode.values.size() > idx) ? cfg_DisplayPrimariesCode.values[idx] : 0);
+    }
+    for(UInt idx=0; idx<2; idx++)
+    {
+      m_masteringDisplay.whitePoint[idx] = UShort((cfg_DisplayWhitePointCode.values.size() > idx) ? cfg_DisplayWhitePointCode.values[idx] : 0);
+    }
+  }
+    
   if( m_toneMappingInfoSEIEnabled && !m_toneMapCancelFlag )
   {
-    Char* pcStartOfCodedInterval = cfg_startOfCodedInterval.empty() ? NULL: strdup(cfg_startOfCodedInterval.c_str());
-    Char* pcCodedPivotValue = cfg_codedPivotValue.empty() ? NULL: strdup(cfg_codedPivotValue.c_str());
-    Char* pcTargetPivotValue = cfg_targetPivotValue.empty() ? NULL: strdup(cfg_targetPivotValue.c_str());
-    if( m_toneMapModelId == 2 && pcStartOfCodedInterval )
-    {
-      char *startOfCodedInterval;
-      UInt num = 1u<< m_toneMapTargetBitDepth;
+    if( m_toneMapModelId == 2 && !cfg_startOfCodedInterval.values.empty() )
+    {
+      const UInt num = 1u<< m_toneMapTargetBitDepth;
       m_startOfCodedInterval = new Int[num];
-      ::memset( m_startOfCodedInterval, 0, sizeof(Int)*num );
-      startOfCodedInterval = strtok(pcStartOfCodedInterval, " .");
-      int i = 0;
-      while( startOfCodedInterval && ( i < num ) )
-      {
-        m_startOfCodedInterval[i] = atoi( startOfCodedInterval );
-        startOfCodedInterval = strtok(NULL, " .");
-        i++;
-      }
-    } 
+      for(UInt i=0; i<num; i++)
+      {
+        m_startOfCodedInterval[i] = cfg_startOfCodedInterval.values.size() > i ? cfg_startOfCodedInterval.values[i] : 0;
+      }
+    }
     else
     {
@@ -1151,27 +1951,12 @@
     if( ( m_toneMapModelId == 3 ) && ( m_numPivots > 0 ) )
     {
-      if( pcCodedPivotValue && pcTargetPivotValue )
-      {
-        char *codedPivotValue;
-        char *targetPivotValue;
-        m_codedPivotValue = new Int[m_numPivots];
+      if( !cfg_codedPivotValue.values.empty() && !cfg_targetPivotValue.values.empty() )
+      {
+        m_codedPivotValue  = new Int[m_numPivots];
         m_targetPivotValue = new Int[m_numPivots];
-        ::memset( m_codedPivotValue, 0, sizeof(Int)*( m_numPivots ) );
-        ::memset( m_targetPivotValue, 0, sizeof(Int)*( m_numPivots ) );
-        codedPivotValue = strtok(pcCodedPivotValue, " .");
-        int i=0;
-        while(codedPivotValue&&i<m_numPivots)
+        for(UInt i=0; i<m_numPivots; i++)
         {
-          m_codedPivotValue[i] = atoi( codedPivotValue );
-          codedPivotValue = strtok(NULL, " .");
-          i++;
-        }
-        i=0;
-        targetPivotValue = strtok(pcTargetPivotValue, " .");
-        while(targetPivotValue&&i<m_numPivots)
-        {
-          m_targetPivotValue[i]= atoi( targetPivotValue );
-          targetPivotValue = strtok(NULL, " .");
-          i++;
+          m_codedPivotValue[i]  = cfg_codedPivotValue.values.size()  > i ? cfg_codedPivotValue.values [i] : 0;
+          m_targetPivotValue[i] = cfg_targetPivotValue.values.size() > i ? cfg_targetPivotValue.values[i] : 0;
         }
       }
@@ -1184,65 +1969,49 @@
   }
 
-#if H_MV
-  // parse PTL
-  Bool anyEmpty = false; 
-  if( cfg_profiles.empty() )
-  {
-#if H_3D
-    cfg_profiles = string("main main 3d-main");
-#else
-    cfg_profiles = string("main main multiview-main");    
-#endif
-    fprintf(stderr, "\nWarning: No profiles given, using defaults: %s", cfg_profiles.c_str() );
-    anyEmpty = true; 
-  }
-
-  if( cfg_levels.empty() )
-  {
-    cfg_levels = string("none none none");
-    fprintf(stderr, "\nWarning: No levels given, using defaults: %s", cfg_levels.c_str() );
-    anyEmpty = true; 
-  }
-
-  if( cfg_tiers.empty() )
-  {
-    cfg_tiers = string("main main main");
-    fprintf(stderr, "\nWarning: No tiers given, using defaults: %s", cfg_tiers.c_str());
-    anyEmpty = true; 
-  }
-
-  if( m_inblFlag.empty() )
-  {
-    fprintf(stderr, "\nWarning: No inblFlags given, using defaults:");
-    for( Int i = 0; i < 3; i++)
-    {
-      m_inblFlag.push_back( false );
-      fprintf(stderr," %d", (Int) m_inblFlag[i]);
-    }
-    anyEmpty = true; 
-  }   
-
-  if ( anyEmpty )
-  {
-    fprintf( stderr, "\n" );
-  }
-
-  xReadStrToEnum( cfg_profiles, m_profile   ); 
-  xReadStrToEnum( cfg_levels,   m_level     ); 
-  xReadStrToEnum( cfg_tiers ,   m_levelTier ); 
-#endif
-#if H_3D
-  // set global varibles
-  xSetGlobal();
-#if H_3D_VSO
-// Table base optimization 
+  if( m_kneeSEIEnabled && !m_kneeSEICancelFlag )
+  {
+    assert ( m_kneeSEINumKneePointsMinus1 >= 0 && m_kneeSEINumKneePointsMinus1 < 999 );
+    m_kneeSEIInputKneePoint  = new Int[m_kneeSEINumKneePointsMinus1+1];
+    m_kneeSEIOutputKneePoint = new Int[m_kneeSEINumKneePointsMinus1+1];
+    for(Int i=0; i<(m_kneeSEINumKneePointsMinus1+1); i++)
+    {
+      m_kneeSEIInputKneePoint[i]  = cfg_kneeSEIInputKneePointValue.values.size()  > i ? cfg_kneeSEIInputKneePointValue.values[i]  : 1;
+      m_kneeSEIOutputKneePoint[i] = cfg_kneeSEIOutputKneePointValue.values.size() > i ? cfg_kneeSEIOutputKneePointValue.values[i] : 0;
+    }
+  }
+
+  if(m_timeCodeSEIEnabled)
+  {
+    for(Int i = 0; i < m_timeCodeSEINumTs && i < MAX_TIMECODE_SEI_SETS; i++)
+    {
+      m_timeSetArray[i].clockTimeStampFlag    = cfg_timeCodeSeiTimeStampFlag        .values.size()>i ? cfg_timeCodeSeiTimeStampFlag        .values [i] : false;
+      m_timeSetArray[i].numUnitFieldBasedFlag = cfg_timeCodeSeiNumUnitFieldBasedFlag.values.size()>i ? cfg_timeCodeSeiNumUnitFieldBasedFlag.values [i] : 0;
+      m_timeSetArray[i].countingType          = cfg_timeCodeSeiCountingType         .values.size()>i ? cfg_timeCodeSeiCountingType         .values [i] : 0;
+      m_timeSetArray[i].fullTimeStampFlag     = cfg_timeCodeSeiFullTimeStampFlag    .values.size()>i ? cfg_timeCodeSeiFullTimeStampFlag    .values [i] : 0;
+      m_timeSetArray[i].discontinuityFlag     = cfg_timeCodeSeiDiscontinuityFlag    .values.size()>i ? cfg_timeCodeSeiDiscontinuityFlag    .values [i] : 0;
+      m_timeSetArray[i].cntDroppedFlag        = cfg_timeCodeSeiCntDroppedFlag       .values.size()>i ? cfg_timeCodeSeiCntDroppedFlag       .values [i] : 0;
+      m_timeSetArray[i].numberOfFrames        = cfg_timeCodeSeiNumberOfFrames       .values.size()>i ? cfg_timeCodeSeiNumberOfFrames       .values [i] : 0;
+      m_timeSetArray[i].secondsValue          = cfg_timeCodeSeiSecondsValue         .values.size()>i ? cfg_timeCodeSeiSecondsValue         .values [i] : 0;
+      m_timeSetArray[i].minutesValue          = cfg_timeCodeSeiMinutesValue         .values.size()>i ? cfg_timeCodeSeiMinutesValue         .values [i] : 0;
+      m_timeSetArray[i].hoursValue            = cfg_timeCodeSeiHoursValue           .values.size()>i ? cfg_timeCodeSeiHoursValue           .values [i] : 0;
+      m_timeSetArray[i].secondsFlag           = cfg_timeCodeSeiSecondsFlag          .values.size()>i ? cfg_timeCodeSeiSecondsFlag          .values [i] : 0;
+      m_timeSetArray[i].minutesFlag           = cfg_timeCodeSeiMinutesFlag          .values.size()>i ? cfg_timeCodeSeiMinutesFlag          .values [i] : 0;
+      m_timeSetArray[i].hoursFlag             = cfg_timeCodeSeiHoursFlag            .values.size()>i ? cfg_timeCodeSeiHoursFlag            .values [i] : 0;
+      m_timeSetArray[i].timeOffsetLength      = cfg_timeCodeSeiTimeOffsetLength     .values.size()>i ? cfg_timeCodeSeiTimeOffsetLength     .values [i] : 0;
+      m_timeSetArray[i].timeOffsetValue       = cfg_timeCodeSeiTimeOffsetValue      .values.size()>i ? cfg_timeCodeSeiTimeOffsetValue      .values [i] : 0;
+    }
+  }
+
+#if NH_3D
+#if NH_3D_VSO
+  // Table base optimization 
   // Q&D
   Double adLambdaScaleTable[] = 
   {  0.031250, 0.031639, 0.032029, 0.032418, 0.032808, 0.033197, 0.033586, 0.033976, 0.034365, 0.034755, 
-     0.035144, 0.035533, 0.035923, 0.036312, 0.036702, 0.037091, 0.037480, 0.037870, 0.038259, 0.038648, 
-     0.039038, 0.039427, 0.039817, 0.040206, 0.040595, 0.040985, 0.041374, 0.041764, 0.042153, 0.042542, 
-     0.042932, 0.043321, 0.043711, 0.044100, 0.044194, 0.053033, 0.061872, 0.070711, 0.079550, 0.088388, 
-     0.117851, 0.147314, 0.176777, 0.235702, 0.294628, 0.353553, 0.471405, 0.589256, 0.707107, 0.707100, 
-     0.753550, 0.800000  
+  0.035144, 0.035533, 0.035923, 0.036312, 0.036702, 0.037091, 0.037480, 0.037870, 0.038259, 0.038648, 
+  0.039038, 0.039427, 0.039817, 0.040206, 0.040595, 0.040985, 0.041374, 0.041764, 0.042153, 0.042542, 
+  0.042932, 0.043321, 0.043711, 0.044100, 0.044194, 0.053033, 0.061872, 0.070711, 0.079550, 0.088388, 
+  0.117851, 0.147314, 0.176777, 0.235702, 0.294628, 0.353553, 0.471405, 0.589256, 0.707107, 0.707100, 
+  0.753550, 0.800000  
   }; 
   if ( m_bUseVSO && m_bVSOLSTable )
@@ -1261,37 +2030,47 @@
     m_dLambdaScaleVSO *= adLambdaScaleTable[m_iQP[firstDepthLayer]]; 
   }
-#endif
-#if H_3D_VSO
-if ( m_bUseVSO && m_uiVSOMode == 4)
-{
-  m_cRenModStrParser.setString( m_iNumberOfViews, m_pchVSOConfig );
+  if ( m_bUseVSO && m_uiVSOMode == 4)
+  {
+    m_cRenModStrParser.setString( m_iNumberOfViews, m_pchVSOConfig );
+    m_cCameraData     .init     ( ((UInt) m_iNumberOfViews ), 
+      m_internalBitDepth[ CHANNEL_TYPE_LUMA],
+      (UInt)m_iCodedCamParPrecision,
+      m_FrameSkip,
+      (UInt)m_framesToBeEncoded,
+      m_pchCameraParameterFile,
+      m_pchBaseViewCameraNumbers,
+      NULL,
+      m_cRenModStrParser.getSynthViews(),
+      LOG2_DISP_PREC_LUT );
+  }
+  else if ( m_bUseVSO && m_uiVSOMode != 4 )
+  {
+    m_cCameraData     .init     ( ((UInt) m_iNumberOfViews ), 
+      m_internalBitDepth[ CHANNEL_TYPE_LUMA],
+      (UInt)m_iCodedCamParPrecision,
+      m_FrameSkip,
+      (UInt)m_framesToBeEncoded,
+      m_pchCameraParameterFile,
+      m_pchBaseViewCameraNumbers,
+      m_pchVSOConfig,
+      NULL,
+      LOG2_DISP_PREC_LUT );
+  }
+  else
+  {
+    m_cCameraData     .init     ( ((UInt) m_iNumberOfViews ), 
+      m_internalBitDepth[ CHANNEL_TYPE_LUMA],
+      (UInt) m_iCodedCamParPrecision,
+      m_FrameSkip,
+      (UInt) m_framesToBeEncoded,
+      m_pchCameraParameterFile,
+      m_pchBaseViewCameraNumbers,
+      NULL,
+      NULL,
+      LOG2_DISP_PREC_LUT );
+  }
+#else
   m_cCameraData     .init     ( ((UInt) m_iNumberOfViews ), 
-                                      g_bitDepthY,
-                                (UInt)m_iCodedCamParPrecision,
-                                      m_FrameSkip,
-                                (UInt)m_framesToBeEncoded,
-                                      m_pchCameraParameterFile,
-                                      m_pchBaseViewCameraNumbers,
-                                      NULL,
-                                      m_cRenModStrParser.getSynthViews(),
-                                      LOG2_DISP_PREC_LUT );
-}
-else if ( m_bUseVSO && m_uiVSOMode != 4 )
-{
-  m_cCameraData     .init     ( ((UInt) m_iNumberOfViews ), 
-                                      g_bitDepthY,
-                                (UInt)m_iCodedCamParPrecision,
-                                      m_FrameSkip,
-                                (UInt)m_framesToBeEncoded,
-                                      m_pchCameraParameterFile,
-                                      m_pchBaseViewCameraNumbers,
-                                      m_pchVSOConfig,
-                                      NULL,
-                                      LOG2_DISP_PREC_LUT );
-}
-else
-{
-  m_cCameraData     .init     ( ((UInt) m_iNumberOfViews ), 
-    g_bitDepthY,
+    m_internalBitDepth[ CHANNEL_TYPE_LUMA],
     (UInt) m_iCodedCamParPrecision,
     m_FrameSkip,
@@ -1302,37 +2081,32 @@
     NULL,
     LOG2_DISP_PREC_LUT );
-}
-#else
-  m_cCameraData     .init     ( ((UInt) m_iNumberOfViews ), 
-    g_bitDepthY,
-    (UInt) m_iCodedCamParPrecision,
-    m_FrameSkip,
-    (UInt) m_framesToBeEncoded,
-    m_pchCameraParameterFile,
-    m_pchBaseViewCameraNumbers,
-    NULL,
-    NULL,
-    LOG2_DISP_PREC_LUT );
 #endif
   m_cCameraData.check( false, true );
 #endif
+
   // check validity of input parameters
   xCheckParameter();
 
-#if !H_3D
-  // set global varibles
-  xSetGlobal();
-#endif
-  
+  // compute actual CU depth with respect to config depth and max transform size
+  UInt uiAddCUDepth  = 0;
+  while( (m_uiMaxCUWidth>>m_uiMaxCUDepth) > ( 1 << ( m_uiQuadtreeTULog2MinSize + uiAddCUDepth )  ) )
+  {
+    uiAddCUDepth++;
+  }
+
+  m_uiMaxTotalCUDepth = m_uiMaxCUDepth + uiAddCUDepth + getMaxCUDepthOffset(m_chromaFormatIDC, m_uiQuadtreeTULog2MinSize); // if minimum TU larger than 4x4, allow for additional part indices for 4:2:2 SubTUs.
+  uiAddCUDepth++;
+  m_uiLog2DiffMaxMinCodingBlockSize = m_uiMaxCUDepth - 1;
+
   // print-out parameters
   xPrintParameter();
-  
+
   return true;
 }
+
+
 // ====================================================================================================================
 // Private member functions
 // ====================================================================================================================
-
-Bool confirmPara(Bool bflag, const Char* message);
 
 Void TAppEncCfg::xCheckParameter()
@@ -1348,5 +2122,5 @@
 
 
-#if !H_MV
+#if !NH_MV
   if( m_profile==Profile::NONE )
   {
